/* UDPtimed.c - main modificado 
# 	Cesar Kallas	RA: 02099224
#	cesarkallas (at) gmx.net 	-	 http://cesarkallas.soulivre.org
#	Pontificia Universidade Catolica - Campinas
#	08/2005
*/

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <stdio.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <arpa/inet.h>
extern int	errno;

int	passiveUDP(const char *service);
int	errexit(const char *format, ...);

#define	UNIXEPOCH	2208988800UL	/* UNIX epoch, in UCT secs	*/
#define NUM_THREADS     10

pthread_t UDPtimed[NUM_THREADS];

/*------------------------------------------------------------------------
 * main - Iterative UDP server for TIME service
 *------------------------------------------------------------------------
*/ 
int
main(int argc, char *argv[])
{
	struct sockaddr_in fsin;	/* the from address of a client	*/
	char	*service = "time";	/* service name or port number	*/
	char	buf[0];			/* "input" buffer; any size > 0	*/
	int	sock;			/* server socket		*/
	time_t	now;			/* current time			*/
	unsigned int	alen;		/* from-address length		*/

	switch (argc) {
	case	1:
		break;
	case	2:
		service = argv[1];
		break;
	default:
		errexit("usage: UDPtimed [port]\n");
	}

	sock = passiveUDP(service);
	int i;
	for(i=0;;i++) {

		alen = sizeof(fsin);

		if (recvfrom(sock, buf, sizeof(buf), 0, (struct sockaddr *)&fsin, &alen) < 0)
			errexit("recvfrom: %s\n", strerror(errno));
		
		printf("Cliente %d: %s\tporta: %d\n", i, inet_ntoa(fsin.sin_addr), ntohs(fsin.sin_port));
		(void) time(&now);
		
		now = htonl((unsigned long)(now + UNIXEPOCH));
		(void) sendto(sock, (char *)&now, sizeof(now), 0,
			(struct sockaddr *)&fsin, sizeof(fsin));
	}
}
